#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;
use Digest::MD5 qw(md5_hex);

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/user.pl';

my $cgi = CGI->new;

my $uid;
my $name;
my $password;

$uid = user::get_uid($cgi->param('name'));
if ($uid eq "") {
	cgilib::header($cgi, "Error");
	print '<center><h1>';
	print 'Unknown User!<p>';
	print '<a href="login.cgi">Retry</a>';
	print '</h1></center>';
	cgilib::footer($cgi);
	exit;
}

($uid, $name, $password) = user::readfile($uid);
if ($password ne md5_hex($cgi->param('password'))) {
	cgilib::header($cgi, "Error");
	print '<center><h1>';
	print 'Invalid Password!<p>';
	print '<a href="login.cgi">Retry</a>';
	print '</h1></center>';
	cgilib::footer($cgi);
	exit;
}

my $session = CGI::Session->new("driver:File", undef,
				{ Directory => './session' });

$session->expire('+30m');
$session->param('uid', $uid);
$session->flush();

my $session_id = $session->id;

cgilib::header($cgi, "Succeed");
print '<center><h1>';
print "Welcome $name !";
print '<br><a href="home.cgi?CGISESSID=' . $session_id . '">Go home</a>';
print '</center></h1>';
cgilib::footer($cgi);
