#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print '<center><h1>';
	print 'Invalid User!<p>';
	print '<a href="login.cgi">Login</a>';
	print '</h1></center>';
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

cgilib::header($cgi, "History");
cgilib::menu($session_id, $name);

print '<center><h3>';
print '<table border=1>';
print '<tr>';
print '<td align=center>Clear Time</td>';
print '<td align=center>Name</td>';
print '<td align=center>Genre</td>';
print '<td align=center>Score</td>';
print '<td align=center>Title</td>';
print '</tr>';

my $qid;
my $u;
my $uqid;
my %clear;
my $t;
my $name;
my $genre;
my $score;
my $title;

foreach $u (user::list()) {
	foreach $qid (question::clear_list($u)) {
		$uqid = $u . "\n" . $qid;
		$clear{$uqid} = question::get_time($u, $qid);
	}
}

foreach $uqid (sort { $clear{$b} <=> $clear{$a} } keys(%clear)) {
	$t = localtime($clear{$uqid});
	($u, $qid) = split(/\n+/, $uqid);
	$name = user::get_name($u);
	$genre = question::get_genre($qid);
	$score = question::get_score($qid);
	$title = question::get_title($qid);
	print '<tr>';
	print "<td align=center>$t</td>";
	print "<td align=center>$name</td>";
	print "<td align=center>$genre</td>";
	print "<td align=center>$score</td>";
	print "<td><a href=\"question.cgi?CGISESSID=$session_id\&qid=$qid\">$title</a></td>";
	print '</tr>';
}

print '</table>';
print '</h3></center>';
cgilib::footer($cgi);
