#!/usr/bin/perl

use strict;
use CGI;
use CGI::Session;

require 'config.pl';
require 'lib/cgilib.pl';
require 'lib/session.pl';
require 'lib/user.pl';
require 'lib/question.pl';

my $cgi = CGI->new;
my $session_id;
my $session;

($session_id, $session) = session::check($cgi);

my $uid = $session->param('uid');
if (!user::is_valid($uid)) {
	cgilib::header($cgi, "Error");
	print '<center><h1>';
	print 'Invalid User!<p>';
	print '<a href="login.cgi">Login</a>';
	print '</h1></center>';
	cgilib::footer($cgi);
	exit;
}

my $name = user::get_name($uid);

cgilib::header($cgi, "Home");
cgilib::menu($session_id, $name);

print '<center><h3>';
print '<table border=1>';
print '<tr>';
print '<td align=center>Number</td>';
print '<td align=center>Genre</td>';
print '<td align=center>Score</td>';
print '<td align=center>Title</td>';
print '<td align=center>Status</td>';
print '</tr>';

my $num = 0;
my $qid;

my $genre;
my $score;
my $title;
my $question;
my @answers;

my $clear;
my $total_score = 0;

my @qid_list = question::list();
foreach $qid (@qid_list) {
	($genre, $score, $title, $question, @answers) = question::readfile($qid);

	$num++;

	if (question::is_clear($uid, $qid)) {
		$clear = "Clear";
	} else {
		$clear = "";
	}

	print '<tr>';
	print "<td align=center>$num</td>";
	print "<td align=center>$genre</td>";
	print "<td align=center>$score</td>";
	print "<td><a href=\"question.cgi?CGISESSID=$session_id\&qid=$qid\">$title</a></td>";
	print "<td align=center>$clear</td>";
	print '</tr>';
}

print '</table>';
print '</h3></center>';

$total_score = question::total_score($uid);

print '<center><h3>';
print "Your total score is ${total_score}.";
print '</h3></center>';

cgilib::footer($cgi);
